
import
  preserves

type
  JsonTranslatorArguments* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: Preserve[void]

  JsonTranslatorConnected* {.preservesRecord: "connected".} = object
    `path`*: string

  JsonSocketTranslatorArguments* {.preservesDictionary.} = object
    `dataspace`* {.preservesEmbedded.}: Preserve[void]
    `socket`*: string

proc `$`*(x: JsonTranslatorArguments | JsonTranslatorConnected |
    JsonSocketTranslatorArguments): string =
  `$`(toPreserve(x))

proc encode*(x: JsonTranslatorArguments | JsonTranslatorConnected |
    JsonSocketTranslatorArguments): seq[byte] =
  encode(toPreserve(x))
